//
// --- initialise the functions
//
exec('Optimisation_Start.sci');
//
// --- initialise the data
//
global NumberOfDesvars NArraySize messages
global BestTarget
global DesignStart BestDesign

DesignStart = ones (100,1);
[Target,DesignStart,DesignMin,DesignMax] = SCILAB_RMOD_K_INIT(DesignStart);
BestTarget = 1.0e+10; 
messages   = 3;
//
// --- initialise the design variables and
//
function Pop_init = myinitga(popsize, param)
    global NumberOfDesvars;
    [Dim,err]       = get_param(param,"dimension",NumberOfDesvars)
    [MaxBounds,err] = get_param(param,"maxbound",2*ones(1,Dim))
    Pop_init = list()
    nr = size(MaxBounds,1)
    nc = size(MaxBounds,2)
    for i=1:popsize
        u = grand(nr,nc,'def');       
        Pop_init(i) = 0.75*(DesignStart.*u + DesignStart);
    end
endfunction
//
// --- initialise the optimisation and
//
PopSize     = 10;
Proba_cross = 0.6;
Proba_mut   = 0.9;
NbGen       = 200;
NbCouples   = 15;
Log         = %T;
pressure    = 0.01;

ga_params = init_param();
ga_params = add_param(ga_params,'minbound',DesignMin);
ga_params = add_param(ga_params,'maxbound',DesignMax);
ga_params = add_param(ga_params,'dimension',NumberOfDesvars);
ga_params = add_param(ga_params,'beta',0.001);
ga_params = add_param(ga_params,'delta',0.1);
ga_params = add_param(ga_params,'nb_couples',NbCouples);
ga_params = add_param(ga_params,'pressure',pressure);
ga_params = add_param(ga_params,'init_func',myinitga);
//
// --- perform the optimisation
//
[pop_opt, fobj_pop_opt, pop_init, fobj_pop_init] = optim_ga(SCILAB_RMOD_K, PopSize, NbGen, Proba_mut, Proba_cross, Log, ga_params);
//
// --- terminate the function
//
Target2 = SCILAB_RMOD_K_TERMINATE(BestDesign)
dos ('copy DesignResults.dat DesignStart.dat')
