#pragma once
#include<math.h>
#include<stdio.h>
#include<stdlib.h>
#include "FormulaDefines.h"
#include "DataPointerContainer.h"

class CDiscreteFormula
{
public:
    CDiscreteFormula( void );
   ~CDiscreteFormula( void );

	CDataPointerContainer *myDataPointerContainer;

	PATCHOUTPUT mypatchoutput;

   int    DiscreteFormula_SetVariables   ( const double *formulavalues, const int nmodelparameter );
   int    DiscreteFormula_SetVariables   (       double *formulavalues, const double *formuladesigns, const int *isdesvar );
   int    DiscreteFormula_SetExVariables ( const int j, const int i, const double value);
   double DiscreteFormula_GetExVariables ( const int j, const int i);
   void DiscreteFormula_Initialize       ( );
   void DiscreteFormula_Evaluate         ( const double *X, double *Y );
   void DiscreteFormula_Terminate        ( );
   void DiscreteFormula_Set_Friction_FB  ( );
	void DiscreteFormula_GetVariables     ( double *formulavalues );

	inline void   set_vslfac       ( double value ) { vslstep       =  value;} 
   inline void   set_version      ( int ivalue   ) { version       = ivalue;} 
   inline void   set_dataexchange ( int ivalue   ) { dataexchange  = ivalue;} 
   inline void   set_draw3d       ( int ivalue   ) { draw3d        = ivalue;} 
   inline int    get_sliding      ()               {return sliding;} 
   inline int    get_version      ()               {return version;} 
   inline int    get_ninside      ()               {return ninside;} 
	inline double get_vslfac       ()               {return vslstep;} 
   inline double get_area         ()               {return Area;} 
   inline double get_dA           ()               {return dA;} 
   inline double get_length       ()               {return h;} 
   inline double get_width        ()               {return b;} 

protected:

   FILE *DiscreteOutput;
   FILE *DiscreteOutputT;

   int    ni,nj,ny,ninside,islide,dataexchange,dataexchangeallocated;
   int    sliding,pressure,draw3d,Nmodelparameter,version,IterateFy;

   double cx0,cx1,cx2,cy0,cy1,cy2,soff;
   double sx0,sy0,muexy,Vmuexy,mueFz,vslstep;
   double mue1xp,cmuexp,mue1xn,cmuexn;
   double mue1yp,cmueyp,mue1yn,cmueyn;
   double mue1x,cmuex,mue1y,cmuey;
   double muex,muey,frica0,frica1;
   double cR,R,Ry,mue0,pin,Fzbar,StiffSca,FrictSca;
   double pi;
	double dataxpow1,dataxpow2,dataypow1,dataypow2,dataypow3,xygamma;

   double h,b,vsx,vsy,fx,fy,u,v,fnij,valij,dxf,dyf;
   double fxsl,fysl,fxst,fyst;

   double sigma0,sigma1,sigma2,sigma3,Fzmag,GammaB;
   double cga,sga,Ryp,Ryp1,dez,vslide0,FxTurnOn,GammaCoeff;
   double sx,sy,st,Fz,VT,gamma,gammaFy,Area,dA;

   double *bmaxj,*bminj,*hi,*vslide,*muslide,**Fzscale;

	sLR_calc          LR_calc;
	sLR_calc_unloaded LR_calc_unloaded;
	sLR_in            LR_in;
	sLR_parameter     Parameter_LR;
	sPAR              Par;

	inline double MySign (const double value) { if ( value < 0.0 ) return (-1.0); return (1.0);};

   double DiscreteFormula_Friction        ();
   double DiscreteFormula_Friction_FB     ();
   void   DiscreteFormula_Area            ();
   void   DiscreteFormula_Area_Ex         ( const double Fz, const double Fy );
   void   DiscreteFormula_Area_Lookup_Ex  ( const double Fz, const double Fy, const double VT );
   void   DiscreteFormula_Area_Lookup     ();
   void   DiscreteFormula_Compute         ( const double *X, double *Y );
   double DiscreteFormula_GetFz           ( const double xi, const double yj, const int i, const int j );
   double DiscreteFormula_Pressure        ( const double xi, const double yj );

   void   calc_loaded_radius_AS_LR_Speed  ( const double Fz, const double Fy, const double VT );

   double   mymax     ( const double value1, const double value2 ) ;
   double   mymin     ( const double value1, const double value2 ) ;
   double **alloc_mat ( int ir, int ic, double fac );
   void      free_mat ( int ir, double **p );
};


