#include "stdafx.h"
#include "Form1.h"

namespace FormulaGUI {

	using namespace System;
	using namespace System::IO;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

//--------------------------------------------------------------------------------------------------
System::Void Form1::localtrackBar_Scroll(System::Object^ sender,  System::EventArgs^ e)
//--------------------------------------------------------------------------------------------------
{
	int i;
	localtrackBar = (System::Windows::Forms::TrackBar^) sender;
	System::Int32::TryParse(localtrackBar->Name,i);
	ShowTrack(i);

	if ( MyGUIData->DataLoaded )
	{
		SetChangedValues(i);
		MyOpenGLPlot->Draw(plotwidth,plotheigth);
		this->label1->Text = L"TargetValue = " + MyGUIData->MyRun->targetvalue.ToString("f4");
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::localtrackBar_Enter(System::Object^ sender,  System::EventArgs^ e)
//--------------------------------------------------------------------------------------------------
{
	int i;

	localtrackBar = (System::Windows::Forms::TrackBar^) sender;
	System::Int32::TryParse(localtrackBar->Name,i);
 
	if ( i == currentslider ) return;
    
	mytextBox1[currentslider]->BackColor::set(System::Drawing::Color::White); 
	mytextBox1[i]->BackColor::set(System::Drawing::Color::LightSkyBlue);
   currentslider = i;
	setrange = 0;

	if ( MyGUIData->DataLoaded ) MyOpenGLPlot->Draw(plotwidth,plotheigth);
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::localtextBox_Edit (System::Object^ sender,  System::EventArgs^ e)
//--------------------------------------------------------------------------------------------------
{
	int i,j;

	if ( MyGUIData->DataLoaded )
	{
		localtextBox = (System::Windows::Forms::TextBox^) sender;
		System::Int32::TryParse(localtextBox->Text,i);
		System::Int32::TryParse(localtextBox->Name,j); 
//
// --- slider value set in textbox window
//
		SetSlider(i,j);
		SetChangedValues(j);
		MyOpenGLPlot->Draw(plotwidth,plotheigth);
		this->label1->Text = L"TargetValue = " + MyGUIData->MyRun->targetvalue.ToString("f4");
		currentslider = j;
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::localcheckBox_Changed (System::Object^ sender,  System::EventArgs^ e)
//--------------------------------------------------------------------------------------------------
{
	int j;

	if ( MyGUIData->DataLoaded )
	{
		localcheckBox = (System::Windows::Forms::CheckBox^) sender;
		System::Int32::TryParse(localcheckBox->Name,j);

		mytextBox1[currentslider]->BackColor::set(System::Drawing::Color::White); 
		mytextBox1[j]->BackColor::set(System::Drawing::Color::LightSkyBlue); 
		currentslider = j;

		if ( localcheckBox->CheckState::get() == System::Windows::Forms::CheckState::Checked   ) this->MyGUIData->MyRun->Set_desvar(j,2);
		if ( localcheckBox->CheckState::get() == System::Windows::Forms::CheckState::Unchecked ) this->MyGUIData->MyRun->Set_desvar(j,0);
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::localtextBox_Enter (System::Object^ sender,  System::EventArgs^ e)
//--------------------------------------------------------------------------------------------------
{
	int    j;

	if ( MyGUIData->DataLoaded )
	{
		localtextBox = (System::Windows::Forms::TextBox^) sender;

		System::Int32::TryParse(localtextBox->Name,j);
		mytextBox1[currentslider]->BackColor::set(System::Drawing::Color::White); 
		mytextBox1[j]->BackColor::set(System::Drawing::Color::LightSkyBlue); 
		currentslider = j;
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::localtextBox_Changed (System::Object^ sender,  System::EventArgs^ e)
//--------------------------------------------------------------------------------------------------
{
	if ( MyGUIData->DataLoaded ) mytrackBar[currentslider]->Value = 33;
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::localtextBox_Leave (System::Object^ sender,  System::EventArgs^ e)
//--------------------------------------------------------------------------------------------------
{
	double value;

	if ( MyGUIData->DataLoaded ) 
	{
		mytextBox1[currentslider]->Text = mytextBox1[currentslider]->Text->Replace(".",",");
		System::Double::TryParse(mytextBox1[currentslider]->Text,value); 
		MyGUIData->MyRun->input1[currentslider] = value; 
		MyGUIData->Evaluate();
		MyOpenGLPlot->Draw(plotwidth,plotheigth);
		this->label1->Text = L"TargetValue = " + MyGUIData->MyRun->targetvalue.ToString("f4");
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::LoadReferenceFile_Click(System::Object^  sender, System::EventArgs^  e) 
//--------------------------------------------------------------------------------------------------
{
	MyGUIData->LoadData();
	if ( MyGUIData->DataLoaded ) 
	{
		MyOpenGLPlot->Set_MeaData (MyGUIData->MyRun->Get_Optidata());
		MyOpenGLPlot->Set_SimData (MyGUIData->MyRun->Get_Simdata ());
		MyOpenGLPlot->Set_MeainfoD(MyGUIData->MyRun->Get_MeainfoD());
		MyOpenGLPlot->Set_MeainfoN(MyGUIData->MyRun->Get_MeainfoN());   
		MyOpenGLPlot->Set_MeainfoF(MyGUIData->MyRun->Get_MeainfoF());  
		MyOpenGLPlot->Set_FileName1(MyGUIData->File1);
		MyOpenGLPlot->Set_FileName2(MyGUIData->File2);
		MyOpenGLPlot->Draw(plotwidth,plotheigth);
		this->label1->Text = L"TargetValue = " + MyGUIData->MyRun->targetvalue.ToString("f4");
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::LoadParameterFile_Click(System::Object^  sender, System::EventArgs^  e) 
//--------------------------------------------------------------------------------------------------
{
	MyGUIData->LoadParameter();
	for ( int i=0; i<NUMBEROFSLIDERS; i++)
	{
		MyGUIData->newinput[i] = MyGUIData->baseinput[i];
		mytrackBar[i]->Value = 33;
		myLabel[i]->Text = MyGUIData->strarray[i];
		mytextBox1[i]->Text = myToString(MyGUIData->baseinput[i]);
		mytextBox2[i]->Text = myToString(MyGUIData->newinput[i]);
		if ( MyGUIData->MyRun->Is_desvar(i) ) mycheckBox[i]->Checked::set(true);
	}
	if ( MyGUIData->DataLoaded ) 
	{
		MyGUIData->Evaluate();
		MyOpenGLPlot->Draw(plotwidth,plotheigth);
		this->label1->Text = L"TargetValue = " + MyGUIData->MyRun->targetvalue.ToString("f4");
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::SaveParameterFile_Click(System::Object^  sender, System::EventArgs^  e) 
//--------------------------------------------------------------------------------------------------
{
	for ( int i=0; i<NUMBEROFSLIDERS; i++)
	{
		 System::Double::TryParse(mytextBox2[i]->Text,MyGUIData->MyRun->input1[i]); 
	}
	MyGUIData->SaveParameter();
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::Sensitivity_Click(System::Object^  sender, System::EventArgs^  e) 
// -------------------------------------------------------------------------------------------------------------
{
	int    i,bestIndex,jslider;
	double value1,value2,value3,value4,bestTarget,bestValue;
   FILE *SENSITY;
   FILE *GNUFILE;
	String ^str;

   if ( currentslider < 0 || currentslider > NUMBEROFSLIDERS-1 ) return;
	if ( MyGUIData->DataLoaded == 0 ) return;

	if ( ( SENSITY = fopen ("sensity.dat","w+") ) == NULL ) return;
//
// --- get base value
//
	System::Double::TryParse(mytextBox1[currentslider]->Text::get(),value1);
	value4 = value1;
//
// --- do sensitivity analysis
//
	jslider = Get_islider();
	this->progressBar1->Maximum = jslider;

	if ( setrange ) 
	{
		value1 = Get_rangemin();
		value2 = Get_rangemax();
		for ( i=0; i<jslider; i++ )
		{
			value3 = value1 + (value2 - value1)*((double) i)/((double)(jslider-1));
			MyGUIData->MyRun->input1[currentslider] = value3;
			MyGUIData->Evaluate();
			fprintf (SENSITY," %+12.6e %+12.6e\n",value3,MyGUIData->target);
			this->progressBar1->Value::set(i);

			if ( i == 0 )
			{
				bestTarget = MyGUIData->target;
				bestValue  = value3;
				bestIndex  = 0;
			}
			else
			{
				if ( bestTarget > MyGUIData->target ) 
				{
					bestTarget = MyGUIData->target;
					bestValue  = value3;
					bestIndex  = i;
				}
			}
		}
	}
	else
	{
		for ( i=0; i<jslider; i++ )
		{
			value3 = value1*(0.5 + 3.0*((double) i)/((double)(jslider-1)));
			MyGUIData->MyRun->input1[currentslider] = value3;
			MyGUIData->Evaluate();
			fprintf (SENSITY," %+12.6e %+12.6e\n",value3,MyGUIData->target);
			this->progressBar1->Value::set(i);

			if ( i == 0 )
			{
				bestTarget = MyGUIData->target;
				bestValue  = value3;
				bestIndex  = 0;
			}
			else
			{
				if ( bestTarget > MyGUIData->target ) 
				{
					bestTarget = MyGUIData->target;
					bestValue  = value3;
					bestIndex  = i;
				}
			}
		}
	}
//
// --- reset drawings
//
	fclose (SENSITY);
	this->progressBar1->Value::set(0);

	MyGUIData->MyRun->input1[currentslider] = value4;
	MyGUIData->Evaluate();
	MyOpenGLPlot->Draw(plotwidth,plotheigth);

	str = this->MyGUIData->strarray[currentslider]->Trim();

	if ( ( GNUFILE = fopen ("sensity.gnu","w+") ) == NULL ) return;
	fprintf  (GNUFILE,"reset\n");
	fprintf  (GNUFILE,"set term win\n");
	fprintf  (GNUFILE,"set title \"variable <%s> with target = %+10.4e at value = %+10.4e [%2d]\"\n",str,bestTarget,bestValue,bestIndex);
	fprintf  (GNUFILE,"set ylabel \"target\"\n");
	fprintf  (GNUFILE,"set xlabel \"variable value\"\n");
	fprintf  (GNUFILE,"set grid\n");
	fprintf  (GNUFILE,"#set yrange [0:10]\n");
	fprintf  (GNUFILE,"plot \\\n");
	fprintf  (GNUFILE,"\"sensity.dat\" u 1:2 notitle w lp lt 1 lw 3\n");
	fprintf  (GNUFILE,"pause -1\n");
	fclose   (GNUFILE);
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::SensitivityAll_Click(System::Object^  sender, System::EventArgs^  e) 
// -------------------------------------------------------------------------------------------------------------
{
	int    i,j,bestIndex,jslider;
	double value1,value3,bestTarget,bestValue;
   FILE *SENSITY;
   FILE *GNUFILE;
	char  s[256];
	String ^str;

	if ( MyGUIData->DataLoaded == 0 ) return;

	if ( ( GNUFILE = fopen ("sensity.gnu","w+") ) == NULL ) return;
	fprintf  (GNUFILE,"reset\n");
	fprintf  (GNUFILE,"set term win\n");
	fprintf  (GNUFILE,"set ylabel \"target\"\n");
	fprintf  (GNUFILE,"set xlabel \"variable value\"\n");
	fprintf  (GNUFILE,"set grid\n");
	fprintf  (GNUFILE,"#set yrange [0:10]\n");

	this->progressBar1->Maximum = NUMBEROFSLIDERS-3;

	jslider = Get_islider();
	for ( j=0; j<NUMBEROFSLIDERS-3; j++ )
	{
		if ( j < 10 ) sprintf (s,"sensity0%d.dat",j);
		else          sprintf (s,"sensity%d.dat",j);

		if ( ( SENSITY = fopen (s,"w+") ) == NULL ) return;
//
// --- get base value
//
		System::Double::TryParse(mytextBox1[j]->Text::get(),value1);
//
// --- do sensitivity analysis
//
		for ( i=0; i<jslider; i++ )
		{
			value3 = value1*(0.5 + 3.0*((double) i)/((double)(jslider-1)));
			MyGUIData->MyRun->input1[j] = value3;
			MyGUIData->Evaluate();
			fprintf (SENSITY," %+12.6e %+12.6e\n",value3,MyGUIData->target);
			this->progressBar1->Value::set(j);

			if ( i == 0 )
			{
				bestTarget = MyGUIData->target;
				bestValue  = value3;
				bestIndex  = 0;
			}
			else
			{
				if ( bestTarget > MyGUIData->target ) 
				{
					bestTarget = MyGUIData->target;
					bestValue  = value3;
					bestIndex  = i;
				}
			}
		}
//
// --- drawings and reset or value 
//
		fclose (SENSITY);
		MyGUIData->Evaluate();
		if   ( bestValues ) MyGUIData->MyRun->input1[j] = bestValue;
		else                MyGUIData->MyRun->input1[j] = value1;

      MyGUIData->MyRun->input1[j] = bestValue;

		MyGUIData->Evaluate();
		MyOpenGLPlot->Draw(plotwidth,plotheigth);

		str = this->MyGUIData->strarray[j]->Trim();
		fprintf  (GNUFILE,"set title \"variable <%s> with target = %+10.4e at value = %+10.4e [%2d/%2d]\"\n",str,bestTarget,bestValue,bestIndex,jslider);
		fprintf  (GNUFILE,"plot \\\n");
		fprintf  (GNUFILE,"\"%s\" u 1:2 notitle w lp lt 1 lw 3\n",s);
		fprintf  (GNUFILE,"pause -1\n");
	}
	fclose   (GNUFILE);
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::BestValues_Click (System::Object^  sender, System::EventArgs^ e) 
//--------------------------------------------------------------------------------------------------
{
	if ( bestValues == 0 ) 
	{
		this->bestValuesToolStripMenuItem->Text = L"IgnoreBestValues";
		bestValues = 1;
	}
	else
	{
		this->bestValuesToolStripMenuItem->Text = L"UseBestValues";
		bestValues = 0;
	}
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::Reset_Click (System::Object^  sender, System::EventArgs^ e) 
//--------------------------------------------------------------------------------------------------
{
	double value1;

   if ( currentslider < 0 || currentslider > NUMBEROFSLIDERS-1 ) return;

	System::Double::TryParse(mytextBox1[currentslider]->Text::get(),value1);
	islider  = 50;
	setrange =  0;
	this->Set_rangemin(value1*0.5);
	this->Set_rangemax(value1*2.0);
	this->Set_islider (islider);
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::Ranges_Click (System::Object^  sender, System::EventArgs^ e) 
//--------------------------------------------------------------------------------------------------
{
	int    i,j;
	double value1;
	String ^string;
   System::Windows::Forms::DialogResult result;

	if ( MyGUIData->DataLoaded == 0 ) return;

	Form^    dlg      = gcnew Form;
   Button^  button1  = gcnew Button;

	System::Double::TryParse(mytextBox1[currentslider]->Text::get(),value1);

	if ( setrange == 0 )
	{
		islider  = 50;
		this->Set_rangemin(value1*0.5);
		this->Set_rangemax(value1*2.0);
		this->Set_islider(islider);
	}

   // --- dialog box with fixed size and centered location without icon and mini/maximize fields
 	dlg->Location    = System::Drawing::Point(220,  112 );
	dlg->Size        = System::Drawing::Size( 290,  110 );
	dlg->MaximumSize = System::Drawing::Size( 290,  370 );
	dlg->MinimumSize = System::Drawing::Size( 290,  110 );
	dlg->MaximizeBox::set(false);
	dlg->MinimizeBox::set(false);
	dlg->ShowIcon::set(false);
	dlg->SizeGripStyle::set(System::Windows::Forms::SizeGripStyle::Hide);
	dlg->StartPosition = System::Windows::Forms::FormStartPosition::Manual;
	dlg->Text = "SelectRanges";

   // --- ResultStepBox settings

   // --- button1 settings
   button1->Location     = System::Drawing::Point( 220, 15);
   button1->Size         = System::Drawing::Size (  50, 23);
   button1->Text         = "Close";
   button1->DialogResult = System::Windows::Forms::DialogResult::OK;

   // --- write into Box
	for ( i=0; i<3; i++ )
	{
		TextBox^ RangeBox = gcnew TextBox;

		RangeBox->Location = System::Drawing::Point(   5,  15+20*i );
		RangeBox->Size     = System::Drawing::Size ( 210,  20   );
		switch (i)
		{
			case 0: 
			{
				string = "Stepwidth Sensitivity    = " + this->Get_islider().ToString("d2");
				RangeBox->Text::set(string);
				break;
			}
			case 1: 
			{
				string = "upper bound Sensitivity = " + myToString(this->Get_rangemax());
				RangeBox->Text::set(string);
				break;
			}
			case 2: 
			{
				string = "lower bound Sensitivity = " + myToString(this->Get_rangemin());
				RangeBox->Text::set(string);
				break;
			}
		}
      myrangeBox[i] = RangeBox;
		dlg->Controls->Add(  myrangeBox[i] );
	}

   // --- added to the dialog box
	dlg->Controls->Add( button1 );

   // --- show the dialog box and get the dialogresult
	result = dlg->ShowDialog();
	if ( result != System::Windows::Forms::DialogResult::OK ) return;

   setrange = 1;

	string = myrangeBox[0]->Text::get();
	i = string->IndexOf(L"=");
	System::Int32::TryParse(string->Substring(i+1),j);
	this->Set_islider(j);

	string = myrangeBox[1]->Text::get();
	i = string->IndexOf(L"=");
	System::Double::TryParse(string->Substring(i+1),value1);
	this->Set_rangemax(value1);

	string = myrangeBox[2]->Text::get();
	i = string->IndexOf(L"=");
	System::Double::TryParse(string->Substring(i+1),value1);
	this->Set_rangemin(value1);

	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw(plotwidth,plotheigth);
}
//--------------------------------------------------------------------------------------------------
System::Void Form1::SaveResultFiles_Click  (System::Object^  sender, System::EventArgs^ e) 
// ------------------------------------------------------------------------------------------------- 
{		
	int    i;
	double value1;

	if ( MyGUIData->ValuesLoaded == 0 ) 
	for ( i=0; i<NUMBEROFSLIDERS; i++ )
	{
		System::Double::TryParse(mytextBox2[i]->Text::get(),value1);
		MyGUIData->MyRun->input1[i] = value1;
	}
	MyGUIData->EvaluateAll();
}
//--------------------------------------------------------------------------------------------------
void Form1::Reset_Click () 
//--------------------------------------------------------------------------------------------------
{
	double value1;

   if ( currentslider < 0 || currentslider > NUMBEROFSLIDERS-1 ) return;

	System::Double::TryParse(mytextBox1[currentslider]->Text::get(),value1);
	islider  = 50;
	setrange = 0;
	this->Set_rangemin(value1*0.5);
	this->Set_rangemax(value1*2.0);
	this->Set_islider (islider);
}
//----------------------------------------------------------------------
void Form1::AddTrack()
//----------------------------------------------------------------------
{
	int ystart = 52;
	int yoff   = 26;
	int xoff   = 100;

	for ( int i=0; i<NUMBEROFSLIDERS; i++ )
	{
		localtrackBar = gcnew System::Windows::Forms::TrackBar;
		localtextBox  = gcnew System::Windows::Forms::TextBox;
		localtextBox1 = gcnew System::Windows::Forms::TextBox;
		localtextBox2 = gcnew System::Windows::Forms::TextBox;
		locallabel    = gcnew System::Windows::Forms::Label;
		localcheckBox = gcnew System::Windows::Forms::CheckBox; 

		// parameter name
		locallabel->Location = System::Drawing::Point(5, 7+yoff*i+ystart);
		locallabel->Name = L"label1";
		locallabel->Size = System::Drawing::Size(64, 14);
		locallabel->Text = L"Paramter" + (i+1).ToString();

		// parameter base value
		localtextBox1->Location = System::Drawing::Point(70, 2+yoff*i+ystart);
		localtextBox1->Size     = System::Drawing::Size( 80,  5 );
		localtextBox1->Text     = L"Paramter" + (i+1).ToString();
		localtextBox1->Name::set(i.ToString());

		// Set up the TrackBar.
		localtrackBar->Location = System::Drawing::Point(xoff+55, 4+yoff*i+ystart);
		localtrackBar->AutoSize = false;
		localtrackBar->Size     = System::Drawing::Size( 200, 20 );
		localtrackBar->Name::set(i.ToString());

		// parameter design variable
		localcheckBox->Location = System::Drawing::Point(xoff+260, 4+yoff*i+ystart);
		localcheckBox->Size     = System::Drawing::Size(20, 17);
		localcheckBox->Name::set(i.ToString());

		// parameter slider value
		localtextBox->Location = System::Drawing::Point(xoff+295, 2+yoff*i+ystart);
		localtextBox->Size     = System::Drawing::Size(  28,  5 );
		localtextBox->Name::set(i.ToString());

		// parameter current value
		localtextBox2->Location = System::Drawing::Point(xoff+330, 2+yoff*i+ystart);
		localtextBox2->Size     = System::Drawing::Size( 80,  5 );
		localtextBox2->Text     = L"Paramter" + (i+1).ToString();
		localtextBox2->Enabled  = false;

		// Set up how the form should be displayed and add the controls to the form.
		array<System::Windows::Forms::Control^>^formControls = {this->localcheckBox,this->localtextBox,this->localtextBox1,this->localtextBox2,this->localtrackBar,this->locallabel};
		this->Controls->AddRange( formControls );
	   	   
		// The Maximum property sets the value of the track bar when
		// the slider is all the way to the right.
		localtrackBar->Maximum = 100;
		localtrackBar->Value    = 33;
	   
		// The TickFrequency property establishes how many positions
		// are between each tick-mark.
		localtrackBar->TickFrequency = 5;
	   
		// The LargeChange property sets how many positions to move
		// if the bar is clicked on either side of the slider.
		localtrackBar->LargeChange = 10;
	   
		// The SmallChange property sets how many positions to move
		// if the keyboard arrows are used to move the slider.
		localtrackBar->SmallChange = 1;

		myLabel[i]    = locallabel;
		mytextBox [i] = localtextBox;
		mytextBox1[i] = localtextBox1;
		mytextBox2[i] = localtextBox2;
		mytrackBar[i] = localtrackBar;
		mycheckBox[i] = localcheckBox;

		mytrackBar[i]->ValueChanged   += gcnew System::EventHandler(this, &Form1::localtrackBar_Scroll);
		mytrackBar[i]->Enter          += gcnew System::EventHandler(this, &Form1::localtrackBar_Enter);
		mytextBox[i]->TextChanged     += gcnew System::EventHandler(this, &Form1::localtextBox_Edit);
		mytextBox[i]->Enter           += gcnew System::EventHandler(this, &Form1::localtextBox_Enter);
		mycheckBox[i]->CheckedChanged += gcnew System::EventHandler(this, &Form1::localcheckBox_Changed);
		mytextBox1[i]->TextChanged    += gcnew System::EventHandler(this, &Form1::localtextBox_Changed);
		mytextBox1[i]->Leave          += gcnew System::EventHandler(this, &Form1::localtextBox_Leave);
		mytextBox1[i]->Enter          += gcnew System::EventHandler(this, &Form1::localtextBox_Enter);
	}
	mytextBox1[0]->BackColor::set(System::Drawing::Color::LightSkyBlue); 
}
//----------------------------------------------------------------------
void Form1::ShowTrack(int i)
//----------------------------------------------------------------------
{
	localtextBox  = mytextBox[i];
	localtrackBar = mytrackBar[i];
	localtextBox->Text = String::Concat( "", localtrackBar->Value );
}
//----------------------------------------------------------------------
void Form1::SetSlider(int i, int j)
//----------------------------------------------------------------------
{		
	if ( i < 0   ) i = 0;
	if ( i > 100 ) i = 100;
	mytrackBar[j]->Value = i;
}
//----------------------------------------------------------------------
void Form1::SetChangedValues(int i)
//----------------------------------------------------------------------
{		
	String ^str;
	double value,value1,value2;
	if ( MyGUIData->ValuesLoaded )
	{
		value  = (double) mytrackBar[i]->Value::get();
		str    = mytextBox1[i]->Text::get();
		System::Double::TryParse(str,value1);
		value2 = value1*(0.5 + 3.0*value/200.0);
		MyGUIData->MyRun->input1[i] = value2;
		mytextBox2[i]->Text = myToString(value2);
		MyGUIData->Evaluate();
		MyOpenGLPlot->Draw(plotwidth,plotheigth);
	}
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::Form1_Activated (System::Object^  sender, System::EventArgs^ e)
// -------------------------------------------------------------------------------------------------------------
{
	if ( MyGUIData->ValuesLoaded == 0 ) MyOpenGLPlot->Draw0(plotwidth,plotheigth);
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::Form1_Click  (System::Object^  sender, System::EventArgs^ e) 
// -------------------------------------------------------------------------------------------------------------
{
	if ( MyGUIData->ValuesLoaded == 1 ) MyOpenGLPlot->Draw(plotwidth,plotheigth);
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::Form1_Paint (System::Object^  sender, System::Windows::Forms::PaintEventArgs^  e)
// -------------------------------------------------------------------------------------------------------------
{
	if ( MyGUIData->ValuesLoaded == 1 ) MyOpenGLPlot->Draw(plotwidth,plotheigth);
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::SelectResults_Click (System::Object^  sender, System::EventArgs^  e)
// -------------------------------------------------------------------------------------------------------------
{
	String ^string;
   System::Windows::Forms::DialogResult result;

   // ---  create the dialog box  
	Form^    dlg      = gcnew Form;

   // --- create dialog elements
   ResultStepBox   = gcnew CheckedListBox;
   Button^ button1 = gcnew Button;

   // --- dialog box with fixed size and centered location without icon and mini/maximize fields
 	dlg->Location    = System::Drawing::Point(220,  112 );
	dlg->Size        = System::Drawing::Size( 290,  170 );
	dlg->MaximumSize = System::Drawing::Size( 290,  370 );
	dlg->MinimumSize = System::Drawing::Size( 290,  170 );
	dlg->MaximizeBox::set(false);
	dlg->MinimizeBox::set(false);
	dlg->ShowIcon::set(false);
	dlg->SizeGripStyle::set(System::Windows::Forms::SizeGripStyle::Hide);
	dlg->StartPosition = System::Windows::Forms::FormStartPosition::Manual;
	dlg->Text = "SelectComponents";

   // --- ResultStepBox settings
   ResultStepBox->Location = System::Drawing::Point(   5,  15 );
   ResultStepBox->Size     = System::Drawing::Size ( 200, 110 );
   ResultStepBox->Items->Clear();
   ResultStepBox->CheckOnClick = true;
   ResultStepBox->SelectionMode = SelectionMode::One;
   ResultStepBox->SelectedIndexChanged += gcnew System::EventHandler(this, &Form1::ResultStepBox_SelectedIndexChanged);

   // --- button1 settings
   button1->Location     = System::Drawing::Point( 220, 15);
   button1->Size         = System::Drawing::Size (  50, 23);
   button1->Text         = "Close";
   button1->DialogResult = System::Windows::Forms::DialogResult::OK;

   // --- write saving points into ResultStepBox

	string = "Reference Force F (Measurement)";
	if ( this->MyOpenGLPlot->Get_M() ) ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                               ResultStepBox->Items->Add(string,::CheckState::Unchecked);

	string = "Total Force F";
	if ( this->MyOpenGLPlot->Get_F() ) ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                               ResultStepBox->Items->Add(string,::CheckState::Unchecked);
                             
	string = "Sticking Force F";
	if ( this->MyOpenGLPlot->Get_FST() ) ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                                 ResultStepBox->Items->Add(string,::CheckState::Unchecked);

	string = "Sliding Force F";
	if ( this->MyOpenGLPlot->Get_FSL() ) ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                                 ResultStepBox->Items->Add(string,::CheckState::Unchecked);

	string = "Accuracy bounds";
	if ( this->MyOpenGLPlot->Get_RANGE() ) ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                                   ResultStepBox->Items->Add(string,::CheckState::Unchecked);

	string = "Plot Legend";
	if ( this->MyOpenGLPlot->Get_Files() ) ResultStepBox->Items->Add(string,::CheckState::Checked);
	else                                   ResultStepBox->Items->Add(string,::CheckState::Unchecked);

   // --- added to the dialog box
	dlg->Controls->Add( button1 );
	dlg->Controls->Add( ResultStepBox );

   // --- show the dialog box and get the dialogresult
	result = dlg->ShowDialog();
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw(plotwidth,plotheigth);
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::ResultStepBox_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e)
// -------------------------------------------------------------------------------------------------------------
{
	int  index;
	bool checked;

	index   = this->ResultStepBox->SelectedIndex;
	checked = this->ResultStepBox->GetItemChecked(index);

	switch (index)
	{
		case 0: { if ( checked ) this->MyOpenGLPlot->Set_M    (1); else this->MyOpenGLPlot->Set_M    (0); break; }
		case 1: { if ( checked ) this->MyOpenGLPlot->Set_F    (1); else this->MyOpenGLPlot->Set_F    (0); break; }
		case 2: { if ( checked ) this->MyOpenGLPlot->Set_FST  (1); else this->MyOpenGLPlot->Set_FST  (0); break; }
		case 3: { if ( checked ) this->MyOpenGLPlot->Set_FSL  (1); else this->MyOpenGLPlot->Set_FSL  (0); break; }
		case 4: { if ( checked ) this->MyOpenGLPlot->Set_RANGE(1); else this->MyOpenGLPlot->Set_RANGE(0); break; }
		case 5: { if ( checked ) this->MyOpenGLPlot->Set_Files(1); else this->MyOpenGLPlot->Set_Files(0); break; }
	}
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw(plotwidth,plotheigth);
}	
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::curveLinesWidthToolStripMenuItem_Click    (System::Object^  sender, System::EventArgs^ e) 
// ----------------------------------------------------------------------------------------------------------------
{
   System::Windows::Forms::DialogResult  result;
	float  wl1,wl2,wl3,wl4,wl5;

   // ---  create the dialog box  
	Form^    dlg                 = gcnew Form;

   // --- create dialog elements
	Label^   label1  = gcnew Label;
	Label^   label2  = gcnew Label;
	Label^   label3  = gcnew Label;
	Label^   label4  = gcnew Label;
	Label^   label5  = gcnew Label;
   Button^  button1 = gcnew Button;

   // --- dialog box with fixed size and centered location without icon and mini/maximize fields
 	dlg->Location    = System::Drawing::Point(220,  112 );
	dlg->Size        = System::Drawing::Size( 290,  170 );
	dlg->MaximumSize = System::Drawing::Size( 290,  370 );
	dlg->MinimumSize = System::Drawing::Size( 290,  170 );
	dlg->MaximizeBox::set(false);
	dlg->MinimizeBox::set(false);
	dlg->ShowIcon::set(false);
	dlg->SizeGripStyle::set(System::Windows::Forms::SizeGripStyle::Hide);
	dlg->StartPosition = System::Windows::Forms::FormStartPosition::Manual;
	dlg->Text = "SelectLineProperties";

   // --- button1 settings
   button1->Location     = System::Drawing::Point( 220, 12);
   button1->Size         = System::Drawing::Size (  50, 23);
   button1->Text         = "Close";
   button1->DialogResult = System::Windows::Forms::DialogResult::OK;

   // --- write saving points into ResultStepBox

   numericUpDown1->Location = System::Drawing::Point(  5, 15);
   numericUpDown2->Location = System::Drawing::Point(  5, 40);
   numericUpDown3->Location = System::Drawing::Point(  5, 65);
   numericUpDown4->Location = System::Drawing::Point(  5, 90);
   numericUpDown5->Location = System::Drawing::Point(  5,115);
   numericUpDown1->Size     = System::Drawing::Size ( 60, 15);
   numericUpDown2->Size     = System::Drawing::Size ( 60, 15);
   numericUpDown3->Size     = System::Drawing::Size ( 60, 15);
   numericUpDown4->Size     = System::Drawing::Size ( 60, 15);
   numericUpDown5->Size     = System::Drawing::Size ( 60, 15);

	numericUpDown1->TextChanged += gcnew System::EventHandler(this, &Form1::numericUpDownTextChanged);
	numericUpDown2->TextChanged += gcnew System::EventHandler(this, &Form1::numericUpDownTextChanged);
	numericUpDown3->TextChanged += gcnew System::EventHandler(this, &Form1::numericUpDownTextChanged);
	numericUpDown4->TextChanged += gcnew System::EventHandler(this, &Form1::numericUpDownTextChanged);
	numericUpDown5->TextChanged += gcnew System::EventHandler(this, &Form1::numericUpDownTextChanged);

	MyOpenGLPlot->Get_LineWidth(&wl1,&wl2,&wl3,&wl4,&wl5);

	numericUpDown1->Value = (int) wl1;
	numericUpDown2->Value = (int) wl2;
	numericUpDown3->Value = (int) wl3;
	numericUpDown4->Value = (int) wl4;
	numericUpDown5->Value = (int) wl5;

	label1->Location = System::Drawing::Point( 75, 15 );
	label1->Size     = System::Drawing::Size( 135, 20 );
   label1->Text     = " Reference Force F";

	label2->Location = System::Drawing::Point( 75, 40 );
	label2->Size     = System::Drawing::Size( 135, 20 );
   label2->Text     = " Total Force F    ";

	label3->Location = System::Drawing::Point( 75, 65 );
	label3->Size     = System::Drawing::Size( 135, 20 );
   label3->Text     = " Sticking Force F ";

	label4->Location = System::Drawing::Point( 75, 90 );
	label4->Size     = System::Drawing::Size( 135, 20 );
   label4->Text     = " Sliding Force F  ";

	label5->Location = System::Drawing::Point( 75,115 );
	label5->Size     = System::Drawing::Size( 135, 20 );
   label5->Text     = " Accuracy Width ";

   // --- added to the dialog box
	dlg->Controls->Add( label1 );
	dlg->Controls->Add( label2 );
	dlg->Controls->Add( label3 ); 
	dlg->Controls->Add( label4 );
	dlg->Controls->Add( label5 );
	dlg->Controls->Add( numericUpDown1 );
	dlg->Controls->Add( numericUpDown2 );
	dlg->Controls->Add( numericUpDown3 );
	dlg->Controls->Add( numericUpDown4 );
	dlg->Controls->Add( numericUpDown5 );
	dlg->Controls->Add( button1 );

   // --- show the dialog box and get the dialogresult
	result = dlg->ShowDialog();

	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw(plotwidth,plotheigth);
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::numericUpDownTextChanged(System::Object^  sender, System::EventArgs^  e)
// -------------------------------------------------------------------------------------------------------------
{
	float  wl1,wl2,wl3,wl4,wl5;

	wl1 = (float) numericUpDown1->Value::get();
	wl2 = (float) numericUpDown2->Value::get();
	wl3 = (float) numericUpDown3->Value::get();
	wl4 = (float) numericUpDown4->Value::get();  
	wl5 = (float) numericUpDown5->Value::get();  

	MyOpenGLPlot->Set_LineWidth(wl1,wl2,wl3,wl4,wl5);

	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw(plotwidth,plotheigth);
}	
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::BuildTarget_Click(System::Object^  sender, System::EventArgs^  e)
// ----------------------------------------------------------------------------------------------------------------
{
	int     i,index;
	String ^string;
	array<String^>^dirs;

   if ( MyGUIData->ValuesLoaded == 0 ) 
	{
		System::Windows::Forms::MessageBox::Show(" Load parameter first","Hint");
		return;
	}

   // ---  create the dialog elements 
	Form^    dlg       = gcnew Form;
   FxBox              = gcnew ListBox;
   FyBox              = gcnew ListBox;
   Files              = gcnew ListBox;
   Button^ button1    = gcnew Button;
   Button^ button2    = gcnew Button;
   Button^ button3    = gcnew Button;
   Button^ button4    = gcnew Button;
   Button^ button5    = gcnew Button;
   Button^ button6    = gcnew Button;
	Label^  label1     = gcnew Label;
	Label^  label2     = gcnew Label;
	Label^  label3     = gcnew Label;
	Label^  label4     = gcnew Label;
	Label^  label5     = gcnew Label;
	
	// --- dialog box with fixed size and centered location without icon and mini/maximize fields
 	dlg->Location    = System::Drawing::Point(220,  112 );
	dlg->Size        = System::Drawing::Size( 480,  320 );
	dlg->MaximizeBox::set(false);
	dlg->MinimizeBox::set(false);
	dlg->ShowIcon::set(false);
	dlg->SizeGripStyle::set(System::Windows::Forms::SizeGripStyle::Hide);
	dlg->StartPosition = System::Windows::Forms::FormStartPosition::Manual;
	dlg->Text = "SelectReferenceDataFiles";

	label1->Location = System::Drawing::Point(  5,  5 );
	label1->Size     = System::Drawing::Size( 100, 20 );
	label1->Text     = "DataFiles";

	label2->Location = System::Drawing::Point(265,  5 );
	label2->Size     = System::Drawing::Size( 100, 20 );
   label2->Text     = L"Selected Fx";

	label3->Location = System::Drawing::Point(265,135 );
	label3->Size     = System::Drawing::Size( 100, 20 );
   label3->Text     = L"Selected Fy";

	label4->Location = System::Drawing::Point(350,262 );
	label4->Size     = System::Drawing::Size(  30, 20 );
   label4->Text     = L"VT =";

	label5->Location = System::Drawing::Point(240,262 );
	label5->Size     = System::Drawing::Size(  55, 20 );
   label5->Text     = L"extension";

   Files->Location = System::Drawing::Point(   5,  20 );
   Files->Size     = System::Drawing::Size ( 200, 225 );
   Files->Items->Clear();
	Files->ScrollAlwaysVisible = true;
	Files->SelectionMode = SelectionMode::MultiExtended;

   FxBox->Location = System::Drawing::Point( 265,  20 );
   FxBox->Size     = System::Drawing::Size ( 200, 100 );
   FxBox->Items->Clear();
	FxBox->Sorted   = true;
	FxBox->ScrollAlwaysVisible = true;
	FxBox->SelectionMode = SelectionMode::MultiExtended;

   FyBox->Location = System::Drawing::Point( 265, 150 );
   FyBox->Size     = System::Drawing::Size ( 200, 100 );
   FyBox->Items->Clear();
	FyBox->Sorted   = true;
	FyBox->ScrollAlwaysVisible = true;
	FyBox->SelectionMode = SelectionMode::MultiExtended;

   // --- button1 settings
   button1->Location     = System::Drawing::Point( 217, 50);
   button1->Size         = System::Drawing::Size (  40, 20);
   button1->Text         = "Add";
	button1->Click        += gcnew System::EventHandler(this, &Form1::BuildTarget_AddFx); 

   button2->Location     = System::Drawing::Point( 217, 75);
   button2->Size         = System::Drawing::Size (  40, 20);
   button2->Text         = "Del";
	button2->Click        += gcnew System::EventHandler(this, &Form1::BuildTarget_DelFx); 

   button3->Location     = System::Drawing::Point( 217,170);
   button3->Size         = System::Drawing::Size (  40, 20);
   button3->Text         = "Add";
	button3->Click        += gcnew System::EventHandler(this, &Form1::BuildTarget_AddFy); 

   button4->Location     = System::Drawing::Point( 217,195);
   button4->Size         = System::Drawing::Size (  40, 20);
   button4->Text         = "Del";
	button4->Click        += gcnew System::EventHandler(this, &Form1::BuildTarget_DelFy); 

   button5->Location     = System::Drawing::Point(   5,257);
   button5->Size         = System::Drawing::Size ( 120, 23);
   button5->Text         = "create new target file";
 	button5->Click        += gcnew System::EventHandler(this, &Form1::StoreTargetFile); 
  
	button6->Location     = System::Drawing::Point( 130,257);
   button6->Size         = System::Drawing::Size ( 100, 23);
   button6->Text         = "load target file";
 	button6->Click        += gcnew System::EventHandler(this, &Form1::LoadTargetFile); 

   vtbox->Location     = System::Drawing::Point( 385,260);
   vtbox->Size         = System::Drawing::Size (  80, 20);
   vtbox->Text         = "16666";

   extension->Location = System::Drawing::Point( 299,260);
   extension->Size     = System::Drawing::Size ( 40, 20);
   extension->Text     = "*.dat";
	extension->Leave   += gcnew System::EventHandler(this, &Form1::BuildTarget_Extension);

	dlg->Controls->Add( Files );
	dlg->Controls->Add( FxBox );
	dlg->Controls->Add( FyBox );
	dlg->Controls->Add( button1 );
	dlg->Controls->Add( button2 );
	dlg->Controls->Add( button3 );
	dlg->Controls->Add( button4 );
	dlg->Controls->Add( button5 );
	dlg->Controls->Add( button6 );
	dlg->Controls->Add( label1 );
	dlg->Controls->Add( label2 );
	dlg->Controls->Add( label3 );
	dlg->Controls->Add( label4 );
	dlg->Controls->Add( label5 );
	dlg->Controls->Add( vtbox );
	dlg->Controls->Add( extension );

	string = MyGUIData->ConvertCharToString(MyGUIData->MyRun->WorkDirectory);
	dirs   = Directory::GetFiles(string,extension->Text);
	for (i=0; i<dirs->Length; i++ )
	{
		index = dirs[i]->LastIndexOf("\\");
		Files->Items->Add(dirs[i]->Substring(index+1));
	}

   dlg->ShowDialog();
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::LoadTargetFile (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	int   direction;
	FILE *INPUTNAME;
	double VT;
	char  s [256];
	char  s2[256];
	char *s1;
   System::Windows::Forms::DialogResult    FileDialog;
	System::Windows::Forms::OpenFileDialog ^ParameterFile;
	String ^File1;

   // --- file selection for solver file, set the initial values of filedialog
   ParameterFile = gcnew System::Windows::Forms::OpenFileDialog;
   ParameterFile->Filter  =  "target file (*.dat)|*.dat|All files (*.*)|*.*";
   ParameterFile->FileName = "DesignTarget.dat";

   FileDialog = ParameterFile->ShowDialog();

   // --- get the name of filedialog and extract the path and the filename of solver file
   if ( FileDialog == System::Windows::Forms::DialogResult::OK ) 
   {
      // --- get the path to the file and the solver filename
		File1 = ParameterFile->FileName::get();
		sprintf (s,"%s",File1);
   }
	if ( ( INPUTNAME = fopen (s,"r+")) == NULL ) return;
//
// --- read target file and prepare Fx and Fy list
//
   fgets ( s,256,INPUTNAME );
   fgets ( s,256,INPUTNAME );
//
// --- read number of data files
//
   while ( fgets ( s,256,INPUTNAME ) )
   {
		if ( strstr ( s,"[Eof]") ) break;
      s1 = strstr ( s,"=" ) + 1;
		sscanf ( s1,"%s",s2);
		s1 = strstr ( s1,"=" ) + 1;
		s1 = strstr ( s1,"=" ) + 1;
		sscanf ( s1,"%d",&direction);
		s1 = strstr ( s1,"=" ) + 1;
		sscanf ( s1,"%lf",&VT);
		if      ( direction == 1 ) FxBox->Items->Add(MyGUIData->ConvertCharToString(s2));
		else if ( direction == 2 ) FyBox->Items->Add(MyGUIData->ConvertCharToString(s2));
		vtbox->Text::set(myToString(VT));
   }
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::BuildTarget_Extension (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	int     i,index;
	String ^string;
	array<String^>^dirs;

	string = MyGUIData->ConvertCharToString(MyGUIData->MyRun->WorkDirectory);
	dirs   = Directory::GetFiles(string,extension->Text);
	Files->Items->Clear();
	for (i=0; i<dirs->Length; i++ )
	{
		index = dirs[i]->LastIndexOf("\\");
		Files->Items->Add(dirs[i]->Substring(index+1));
	}
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::BuildTarget_AddFx (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Collections::IEnumerator ^num;

	if  ( Files->SelectedItems->Count == 1 ) FxBox->Items->Add(Files->Text::get());
	else
	{
		num = Files->SelectedItems->GetEnumerator();
		while ( num->MoveNext() ) FxBox->Items->Add(num->Current::get());
	}
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::BuildTarget_DelFx (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	if  ( FxBox->SelectedItems->Count > 0 ) FxBox->Items->RemoveAt(FxBox->SelectedIndex);
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::BuildTarget_AddFy (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Collections::IEnumerator ^num;

	if  ( Files->SelectedItems->Count == 1 ) FyBox->Items->Add(Files->Text::get());
	else
	{
		num = Files->SelectedItems->GetEnumerator();
		while ( num->MoveNext() ) FyBox->Items->Add(num->Current::get());
	}
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::BuildTarget_DelFy (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	if  ( FyBox->SelectedItems->Count > 0 ) FyBox->Items->RemoveAt(FyBox->SelectedIndex);
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::StoreTargetFile (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	int   i,j,ivalue,entries;
	FILE *OUTPUT;
	FILE *DATA;
	char s [256];
   System::Windows::Forms::DialogResult    FileDialog;
	System::Windows::Forms::SaveFileDialog ^ParameterFile;
	String ^File1;
	String ^string;

   // --- file selection for solver file, set the initial values of filedialog
   ParameterFile = gcnew System::Windows::Forms::SaveFileDialog;
   ParameterFile->Filter  =  "target file (*.dat)|*.dat|All files (*.*)|*.*";
   ParameterFile->FileName = "DesignTargetNew.dat";

   FileDialog = ParameterFile->ShowDialog();

   // --- get the name of filedialog and extract the path and the filename of solver file
   if ( FileDialog == System::Windows::Forms::DialogResult::OK ) 
   {
      // --- get the path to the file and the solver filename
		File1 = ParameterFile->FileName::get();
		sprintf (MyGUIData->MyRun->OptiFileName,"%s",File1);
   }
	if ( ( OUTPUT = fopen (MyGUIData->MyRun->OptiFileName,"w+")) == NULL ) return; 
//
// --- header of design target file
// 
	fprintf (OUTPUT,"[DataFileName and Size]\n");
	fprintf (OUTPUT,"Number of Files = %d\n",FxBox->Items->Count::get()+FyBox->Items->Count::get());
	entries = FxBox->Items->Count::get();
//
// --- analyse files for longitudinal direction
//
	j = 1;
	entries = FxBox->Items->Count::get();
	for (i=0; i<entries; i++)
	{
		FxBox->ClearSelected();
		FxBox->SetSelected(i,true);
		File1 = MyGUIData->ConvertCharToString(MyGUIData->MyRun->WorkDirectory) + FxBox->Text::get();
		MyGUIData->ConvertStringToChar(File1,s);
		if ( ( DATA = fopen (s,"r+")) == NULL ) return; 
		ivalue = 0;
		while ( fgets (s,256,DATA) ) {ivalue++;}
		string = vtbox->Text::get()->Replace(",",".");
		fprintf (OUTPUT,"Datafile%d = %s Size = %d dir = 1 VT = %s \n",j,FxBox->Text::get(),ivalue,string);
		fclose(DATA);
		j++;
	}
//
// --- analyse files for lateral direction
//
	entries = FyBox->Items->Count::get();
	for (i=0; i<entries; i++)
	{
		FyBox->ClearSelected();
		FyBox->SetSelected(i,true);
		File1 = MyGUIData->ConvertCharToString(MyGUIData->MyRun->WorkDirectory) + FyBox->Text::get();
		MyGUIData->ConvertStringToChar(File1,s);
		if ( ( DATA = fopen (s,"r+")) == NULL ) return; 
		ivalue = 0;
		while ( fgets (s,256,DATA) ) {ivalue++;}
		string = vtbox->Text::get()->Replace(",",".");
		fprintf (OUTPUT,"Datafile%d = %s Size = %d dir = 2 VT = %s \n",j,FyBox->Text::get(),ivalue,string);
		fclose(DATA);
		j++;
	}
	fprintf (OUTPUT,"[Eof]\n");
	fclose(OUTPUT);
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::ColorDialog_Click (System::Object^  sender, System::EventArgs^  e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_Background(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw(plotwidth,plotheigth);
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::referenceColorToolStripMenuItem_Click     (System::Object^  sender, System::EventArgs^ e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_MeaForce(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw(plotwidth,plotheigth);
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::totalForceColorToolStripMenuItem_Click    (System::Object^  sender, System::EventArgs^ e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_SimForce(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw(plotwidth,plotheigth);
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::stickingForceColorToolStripMenuItem_Click (System::Object^  sender, System::EventArgs^ e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_FSTForce(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw(plotwidth,plotheigth);
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::slidingForceColorToolStripMenuItem_Click  (System::Object^  sender, System::EventArgs^ e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_FSLForce(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw(plotwidth,plotheigth);
}
// ----------------------------------------------------------------------------------------------------------------
System::Void Form1::AccuracyBoundsColor_Click  (System::Object^  sender, System::EventArgs^ e) 
// ----------------------------------------------------------------------------------------------------------------
{
	System::Windows::Forms::ColorDialog^ CD = gcnew ColorDialog;
	CD->ShowDialog(this);	
	this->MyOpenGLPlot->Set_RangeForce(CD->Color.A,CD->Color.R,CD->Color.G,CD->Color.B);
	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw(plotwidth,plotheigth);
}
// -------------------------------------------------------------------------------------------------------------
System::Void Form1::AboutToolStrip_Click(System::Object^  sender, System::EventArgs^  e)
// -------------------------------------------------------------------------------------------------------------
{
	Form^    dlg    = gcnew Form;
	Label^  label1  = gcnew Label;
	Label^  label2  = gcnew Label;
	Label^  label3  = gcnew Label;
	Label^  label4  = gcnew Label;

   // --- create dialog elements

   // --- dialog box with fixed size and centered location without icon and mini/maximize fields
   dlg->Size        = System::Drawing::Size( 320,  160 );
	dlg->MaximumSize = System::Drawing::Size( 320,  360 );
	dlg->MinimumSize = System::Drawing::Size( 320,  160 );
	dlg->MaximizeBox::set(false);
	dlg->MinimizeBox::set(false);
	dlg->ShowIcon::set(false);
	dlg->BackColor::set(System::Drawing::Color::LightGray);
	dlg->SizeGripStyle::set(System::Windows::Forms::SizeGripStyle::Hide);
	dlg->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
	dlg->Text = "Information";

	label1->Location = System::Drawing::Point( 25, 15 );
	label1->Size     = System::Drawing::Size( 315, 20 );
	label1->Text     = "RMOD-K Formula GUI Version 2.01 from 15.08.2014 ";

	label2->Location = System::Drawing::Point( 25, 40 );
	label2->Size     = System::Drawing::Size( 255, 20 );
   label2->Text     = L"RMOD-K FormulaVersion 2.01 from 15.08.2014 ";

	label3->Location = System::Drawing::Point( 25, 65 );
	label3->Size     = System::Drawing::Size( 255, 20 );
   label3->Text     = L"Copyright IAT Dynamics 15.08.2014 ";

	label4->Location = System::Drawing::Point( 25, 90 );
	label4->Size     = System::Drawing::Size( 255, 20 );
   label4->Text     = L"Further Information www.rmod-k.com";

   // --- added to the dialog box
	dlg->Controls->Add( label1 );
	dlg->Controls->Add( label2 );
	dlg->Controls->Add( label3 );
	dlg->Controls->Add( label4 );
   dlg->ShowDialog();

	if ( MyGUIData->DataLoaded ) this->MyOpenGLPlot->Draw(plotwidth,plotheigth);
}
// -------------------------------------------------------------------------------------
System::Void Form1::OpenHelpToolStrip_Click(System::Object^  sender, System::EventArgs^  e)
// -------------------------------------------------------------------------------------
// open help file if OpenHelpToolStrip clicked
// -------------------------------------------------------------------------------------
{
	String ^string;

	string = L"GUI.chm";
   Help::ShowHelp(this,string);
}
// -------------------------------------------------------------------------------------
String ^Form1::myToString (double value)  
// -------------------------------------------------------------------------------------
{
	if ( fabs(value) < 10000.0 && fabs(value) > 0.0001 ) return (value.ToString("f6"));
	else                                                 return (value.ToString("e5"));
}
}