#ifndef _SFUN_RMOD_K_CPP_
#define _SFUN_RMOD_K_CPP_

#define S_FUNCTION_NAME  RMOD_K_Formula_S_function 
#define S_FUNCTION_LEVEL 2
#define MATLAB_MEX_FILE

#define NUM_INPUTS          5
/* Input Port  0 */
#define IN_PORT_0_NAME      vx
#define INPUT_0_WIDTH       1
#define INPUT_DIMS_0_COL    1
#define INPUT_0_DTYPE       real_T
#define INPUT_0_COMPLEX     COMPLEX_NO
#define IN_0_FRAME_BASED    FRAME_NO
#define IN_0_DIMS           1-D
#define INPUT_0_FEEDTHROUGH 1

/* Input Port  1 */
#define IN_PORT_1_NAME      vy
#define INPUT_1_WIDTH       1
#define INPUT_DIMS_1_COL    1
#define INPUT_1_DTYPE       real_T
#define INPUT_1_COMPLEX     COMPLEX_NO
#define IN_1_FRAME_BASED    FRAME_NO
#define IN_1_DIMS           1-D
#define INPUT_1_FEEDTHROUGH 1

/* Input Port  2 */
#define IN_PORT_2_NAME      Omega
#define INPUT_2_WIDTH       1
#define INPUT_DIMS_2_COL    1
#define INPUT_2_DTYPE       real_T
#define INPUT_2_COMPLEX     COMPLEX_NO
#define IN_2_FRAME_BASED    FRAME_NO
#define IN_2_DIMS           1-D
#define INPUT_2_FEEDTHROUGH 1

// /* Input Port  3 */
#define IN_PORT_3_NAME      Fn
#define INPUT_3_WIDTH       1
#define INPUT_DIMS_3_COL    1
#define INPUT_3_DTYPE       real_T
#define INPUT_3_COMPLEX     COMPLEX_NO
#define IN_3_FRAME_BASED    FRAME_NO
#define IN_3_DIMS           1-D
#define INPUT_3_FEEDTHROUGH 1

// /* Input Port  4 */
#define IN_PORT_4_NAME      V
#define INPUT_4_WIDTH       1
#define INPUT_DIMS_4_COL    1
#define INPUT_4_DTYPE       real_T
#define INPUT_4_COMPLEX     COMPLEX_NO
#define IN_4_FRAME_BASED    FRAME_NO
#define IN_4_DIMS           1-D
#define INPUT_4_FEEDTHROUGH 1

#define NUM_OUTPUTS          3
/* Output Port  0 */
#define OUT_PORT_0_NAME      Fx
#define OUTPUT_0_WIDTH       1
#define OUTPUT_DIMS_0_COL    1
#define OUTPUT_0_DTYPE       real_T
#define OUTPUT_0_COMPLEX     COMPLEX_NO
#define OUT_0_FRAME_BASED    FRAME_NO
#define OUT_0_DIMS           1-D
// /* Output Port  1 */
#define OUT_PORT_1_NAME      Fy
#define OUTPUT_1_WIDTH       1
#define OUTPUT_DIMS_1_COL    1
#define OUTPUT_1_DTYPE       real_T
#define OUTPUT_1_COMPLEX     COMPLEX_NO
#define OUT_1_FRAME_BASED    FRAME_NO
#define OUT_1_DIMS           1-D
// /* Output Port  2 */
#define OUT_PORT_2_NAME      Mz
#define OUTPUT_2_WIDTH       1
#define OUTPUT_DIMS_2_COL    1
#define OUTPUT_2_DTYPE       real_T
#define OUTPUT_2_COMPLEX     COMPLEX_NO
#define OUT_2_FRAME_BASED    FRAME_NO
#define OUT_2_DIMS           1-D

#define SAMPLE_TIME_0        INHERITED_SAMPLE_TIME
#define NUM_DISC_STATES      0
#define DISC_STATES_IC       [0]
#define NUM_CONT_STATES      0
#define CONT_STATES_IC       [0]

#endif

#pragma once
#include "DiscreteFormula.h"
#include "ContinusFormula.h"
#include "FormulaDefines.h"
#include "simstruc.h"
#include <string.h>

class CRMOD_K_Formula_S_function
{

public:

	CRMOD_K_Formula_S_function::CRMOD_K_Formula_S_function( void )
	{
		myDiscreteFormula = new CDiscreteFormula;
		myContinusFormula = new CContinusFormula;
	}

	CRMOD_K_Formula_S_function::~CRMOD_K_Formula_S_function( void )
	{
	}
   char DataFileName[256];

	       int   ReadFile_Formula ( char *s );
			 void  Evaluate_Formula ( const double *input3, double *output );
			 void Terminate_Formula ( );
	inline void set_draw3d       ( int mode ) {myDiscreteFormula->set_draw3d( mode );};

   int     m1;
   double  input1[NMODELPARAMETER];

protected:

   int    get_integevalue (const char *s);
   double get_doublevalue (const char *s);

   int    model;

   CDiscreteFormula *myDiscreteFormula;
   CContinusFormula *myContinusFormula;
};
